Name: qmail
Version: 1.03+patches
Release: 2
Group: Networking/Daemons
URL: http://www.qmail.org/
Copyright: Check with djb@koobera.math.uic.edu
Packager: Bruce Guenter <bruce.guenter@qcc.sk.ca>
Source0: ftp://koobera.math.uic.edu/pub/software/qmail-1.03.tar.gz
Source1: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail.init
Source2: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail.sh
Source3: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail.csh
Source4: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmtpd.init
Source5: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/smtpd.init
Source6: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/pop3d.init
Source7: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmqpd.init
Source8: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-functions.init
Source9: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/INSTALL.redhat
Source10: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-init.8
Source11: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/dot.qmail-msglog
Patch0: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-msglog.patch
Patch1: http://madhaus.utcs.utoronto.ca/qmail/qmail-1.03-smtpd-newline.patch
Patch2: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-condredirect.patch
Patch3: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-showctl.patch
Patch4: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-bind-interface.patch
Patch5: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-install-path.patch
Patch6: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-autouidgid.patch
Patch7: http://www.qcc.sk.ca/~bguenter/distrib/qmail+patches/qmail-1.03-fdirsync.patch
Summary: Qmail Mail Transfer Agent
Provides: MTA, smtpdaemon
Conflicts: sendmail
BuildRoot: /tmp/qmail
Requires: chkconfig
Requires: daemontools = 0.53+patches
Requires: sh-utils
Requires: shadow-utils
Requires: qmail-utils = %{PACKAGE_VERSION}

%description
Qmail is a small, fast, secure replacement for the sendmail package,
which is the program that actually receives, routes, and delivers
electronic mail.  *** Note: Be sure and read the documentation as there
are some small but very significant differences between sendmail and
qmail and the programs that interact with them.

%package utils
Group: Applications/Mail
Summary: qmail tools for mail access
%description utils
Support files and programs from qmail for sending and receiving mail
under user control on a system.

%package pop3d
Group: Networking/Daemons
Summary: POP3 server support for qmail
Provides: pop3daemon
Requires: qmail = %{PACKAGE_VERSION}
Requires: chkconfig
Requires: daemontools = 0.53+patches
Requires: sh-utils
Requires: ucspi-tcp >= 0.80-1
%description pop3d
Support files for running the qmail POP3 server.

%package qmtpd
Group: Networking/Daemons
Summary: QMTP server support for qmail
Provides: qmtpdaemon
Requires: qmail = %{PACKAGE_VERSION}
Requires: chkconfig
Requires: daemontools = 0.53+patches
Requires: sh-utils
Requires: ucspi-tcp >= 0.80-1
%description qmtpd
Support files for running the qmail QMTP server.

%package smtpd
Group: Networking/Daemons
Summary: SMTP server support for qmail
Requires: qmail = %{PACKAGE_VERSION}
Requires: chkconfig
Requires: daemontools = 0.53+patches
Requires: sh-utils
Requires: ucspi-tcp >= 0.80-1
%description smtpd
Support files for running the qmail SMTP server.

%package qmqpd
Group: Networking/Daemons
Summary: QMQP server support for qmail
Provides: qmqpdaemon
Requires: qmail = %{PACKAGE_VERSION}
Requires: chkconfig
Requires: daemontools = 0.53+patches
Requires: sh-utils
Requires: ucspi-tcp >= 0.80-1
%description qmqpd
Support files for running the qmail QMQP server.

%prep
%setup -n qmail-1.03
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

echo "gcc $RPM_OPT_FLAGS" >conf-cc
echo "gcc -s $RPM_OPT_FLAGS" >conf-ld

for source in pop3d.init qmail.init qmqpd.init qmtpd.init smtpd.init \
	qmail-functions.init INSTALL.redhat qmail-init.8 \
	qmail.csh qmail.sh dot.qmail-msglog
do
	cp $RPM_SOURCE_DIR/$source .
done

%build

make it man

%install
export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
add_user() { useradd -d "$3" -g "$2" -M -r -s /bin/true "$1" || true }
add_group() { groupadd -r "$1" || true }
install_file() {
	source="$1"
	dest="$2"
	shift 2
	install "$@" "$source" $RPM_BUILD_ROOT/"$dest"
}

add_group qmail
add_group nofiles

add_user alias  nofiles /etc/qmail/alias
add_user qmaild nofiles /var/qmail
add_user qmaill nofiles /var/qmail
add_user qmailp nofiles /var/qmail
add_user qmailq qmail   /var/qmail
add_user qmailr qmail   /var/qmail
add_user qmails qmail   /var/qmail

/bin/rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
pushd $RPM_BUILD_ROOT
  install -d etc/profile.d
  install -d -o alias -g qmail etc/qmail/alias
  install -d -o root -g qmail etc/qmail
  install -d -g qmail etc/qmail/control
  install -d -g qmail etc/qmail/owners
  install -d -g qmail etc/qmail/users
  install -d etc/rc.d/init.d
  install -d etc/rc.d/rc0.d
  install -d etc/rc.d/rc1.d
  install -d etc/rc.d/rc2.d
  install -d etc/rc.d/rc3.d
  install -d etc/rc.d/rc4.d
  install -d etc/rc.d/rc5.d
  install -d etc/rc.d/rc6.d
  install -d etc/tcpcontrol
  install -d usr/bin
  install -d usr/lib
  install -d usr/man
  install -d usr/sbin
  install -d -g qmail var/qmail
  install -d -g qmail var/lock/svc/{qmail,qmtpd,smtpd,pop3d,qmqpd}
  install -d -o qmaill -g qmail var/log/{qmail,qmtpd,smtpd,pop3d,qmqpd}

  ln -s ../../etc/qmail/alias var/qmail/alias
  ln -s ../../etc/qmail/control var/qmail/control
  ln -s ../../etc/qmail/owners var/qmail/owners
  ln -s ../../etc/qmail/users var/qmail/users
  ln -s ../../usr/bin var/qmail/bin
  ln -s ../../usr/man var/qmail/man
popd

# Build the user and group files, required for qmail-hier
./make-owners .
# INSTALL IT
./install $RPM_BUILD_ROOT/var/qmail
# CHECK IT
./instcheck $RPM_BUILD_ROOT/var/qmail
install_file qmail-init.8 usr/man/man8 -m 644

# Remove preformatted man pages
rm -rf $RPM_BUILD_ROOT/var/qmail/man/cat*
rm $RPM_BUILD_ROOT/var/qmail/man

# Fix for sendmail add-ons
pushd $RPM_BUILD_ROOT/usr
  mv bin/sendmail sbin/sendmail
  ln -s ../sbin/sendmail bin/mailq
  ln -s ../sbin/sendmail lib/sendmail
  chown qmails.qmail bin/qmail-qread
  chmod ug+s,go-r bin/qmail-qread
popd

# Install some extra configuration programs
install config dnsfq dnsip dnsptr hostname ipmeprint $RPM_BUILD_ROOT/usr/bin

# Install extra shell scripts to provide environment variables
install_file qmail.sh etc/profile.d -m 755
install_file qmail.csh etc/profile.d -m 755
install_file qmail-functions.init etc/rc.d/init.d/qmail-functions -m 644
for init in qmail qmtpd smtpd pop3d qmqpd; do
	install_file ${init}.init etc/rc.d/init.d/$init -m 755
done

install_file dot.qmail-msglog etc/qmail/alias/.qmail-msglog

pushd $RPM_BUILD_ROOT/etc/qmail/alias
  touch .qmail-postmaster .qmail-mailer-daemon .qmail-root
  chmod 644 .qmail*
popd

pushd $RPM_BUILD_ROOT/etc/qmail/control
  touch defaultdomain locals me plusdomain rcpthosts
  chmod 644 defaultdomain locals me plusdomain rcpthosts
popd

$RPM_BUILD_ROOT/usr/bin/make-owners $RPM_BUILD_ROOT/etc/qmail

cat <<EOFaliasempty >$RPM_BUILD_ROOT/etc/qmail/control/aliasempty
|dot-forward .forward
|preline procmail
EOFaliasempty

cat <<EOFlogger >$RPM_BUILD_ROOT/etc/qmail/control/logger
accustamp | setuser qmaill cyclog
EOFlogger

pushd $RPM_BUILD_ROOT/etc/qmail/users
  touch assign
  touch include
  touch exclude
  touch mailnames
  touch subusers
  touch append
popd

# rebuild the sym-links under /var/qmail
pushd $RPM_BUILD_ROOT/var/qmail
  rm -f alias control users owners bin man
  ln -s /etc/qmail/alias alias
  ln -s /etc/qmail/control control
  ln -s /etc/qmail/owners owners
  ln -s /etc/qmail/users users
  ln -s /usr/bin bin
  ln -s /usr/man man
  rm -rf boot
  rm -rf doc
  ln -s /usr/doc/qmail-$RPM_PACKAGE_VERSION doc
popd

# Build the default tcpcontrol rules & CDBs
pushd $RPM_BUILD_ROOT/etc/tcpcontrol
  echo :allow >pop-3.rules
  echo :deny >qmqp.rules
  echo :allow >qmtp.rules
  echo :allow >smtp.rules
  tcprules pop-3.cdb pop-3.tmp <pop-3.rules
  tcprules qmqp.cdb qmqp.tmp <qmqp.rules
  tcprules qmtp.cdb qmtp.tmp <qmtp.rules
  tcprules smtp.cdb smtp.tmp <smtp.rules
popd

%clean
rm -rf $RPM_BUILD_ROOT

# Pre/Post-install Scripts #####################################################
%pre
PATH="/sbin:/usr/sbin:$PATH" export PATH
add_user() { useradd -d "$3" -g "$2" -M -r -s /bin/true "$1" }
add_group() { groupadd -r "$1" }

if [ $1 = 2 ]; then
	# Disable deliveries if upgrading
	test -d /etc/qmail/alias && chmod +t /etc/qmail/alias
	test -d /var/qmail/alias && chmod +t /var/qmail/alias
	test -d /home && chmod +t /home/*
else
	add_group qmail
	add_group nofiles

	add_user alias  nofiles /etc/qmail/alias
	add_user qmaild nofiles /var/qmail
	add_user qmaill nofiles /var/qmail
	add_user qmailp nofiles /var/qmail
	add_user qmailq qmail   /var/qmail
	add_user qmailr qmail   /var/qmail
	add_user qmails qmail   /var/qmail
fi

%post
if [ $1 = 2 ]; then
  # Re-enable deliveries on upgrading
  test -d /etc/qmail/alias && chmod -t /etc/qmail/alias
  test -d /var/qmail/alias && chmod -t /var/qmail/alias
  test -d /home && chmod -t /home/*
else
  cd /var/qmail/bin
  ./config
fi
/usr/bin/make-owners /etc/qmail
/sbin/chkconfig --add qmail
echo "See the qmail-init man page for details about starting and stopping qmail."

%post pop3d
/sbin/chkconfig --add pop3d

%post qmqpd
/sbin/chkconfig --add qmqpd

%post qmtpd
/sbin/chkconfig --add qmtpd

%post smtpd
/sbin/chkconfig --add smtpd
cd /etc
test -e inetd.conf.rpmsave || cp inetd.conf inetd.conf.rpmsave
sed	-e 's/^smtp[ 	]/#smtp	/' \
	inetd.conf >inetd.conf.new
mv inetd.conf.new inetd.conf
echo "inetd may need to be restarted before incoming SMTP connections"
echo "will work.  You can do this by typing 'killall -HUP inetd' or equivalent"

%preun
if [ $1 -gt 0 ]; then exit 0; fi

test -x /etc/rc.d/init.d/qmail && /etc/rc.d/init.d/qmail

/sbin/chkconfig --del qmail
echo "Removing Qmail user ids..."
userdel alias
userdel qmaild
userdel qmaill
userdel qmailp
userdel qmailq
userdel qmailr
userdel qmails

echo "Removing Qmail group ids..."
groupdel qmail
groupdel nofiles

%preun pop3d
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/pop3d && /etc/rc.d/init.d/pop3d stop
/sbin/chkconfig --del pop3d

%preun qmqpd
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/qmqpd && /etc/rc.d/init.d/qmqpd stop
/sbin/chkconfig --del qmqpd

%preun qmtpd
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/qmtpd && /etc/rc.d/init.d/qmtpd stop
/sbin/chkconfig --del qmtpd

%preun smtpd
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/smtpd && /etc/rc.d/init.d/smtpd stop
/sbin/chkconfig --del smtpd

# Files List ###################################################################
%files
%defattr(-,-,qmail)
%dir /etc/qmail

%attr(2755, alias, qmail) %dir /etc/qmail/alias/
%attr(-, alias, qmail) %config(noreplace) /etc/qmail/alias/.qmail-*

%dir /etc/qmail/owners
%config /etc/qmail/owners/*

%dir /etc/qmail/users
%ghost %config(missingok,noreplace) %verify(user,group,mode) /etc/qmail/users/*

%dir /etc/qmail/control
%ghost %config(missingok,noreplace) /etc/qmail/control/defaultdomain
%ghost %config(missingok,noreplace) /etc/qmail/control/locals
%ghost %config(missingok,noreplace) /etc/qmail/control/plusdomain
%ghost %config(missingok,noreplace) /etc/qmail/control/rcpthosts
%verify(mode,group,user) %config(noreplace) /etc/qmail/control/me

/etc/rc.d/init.d/qmail
/etc/rc.d/init.d/qmail-functions

%doc BLURB BLURB2 BLURB3 BLURB4 CHANGES FAQ FILES INSTALL INSTALL.*
%doc INTERNALS PIC.* README REMOVE.* SECURITY SENDMAIL TEST.*
%doc THANKS THOUGHTS TODO UPGRADE

/usr/bin/config
/usr/bin/dnsfq
/usr/bin/dnsip
/usr/bin/dnsptr
/usr/bin/hostname
/usr/bin/ipmeprint
/usr/bin/make-owners
%attr(0711,root,qmail) /usr/bin/qmail-clean
%attr(0711,root,qmail) /usr/bin/qmail-getpw
%attr(0711,root,qmail) /usr/bin/qmail-local
%attr(0700,root,qmail) /usr/bin/qmail-lspawn
%attr(0700,root,qmail) /usr/bin/qmail-newmrh
%attr(0700,root,qmail) /usr/bin/qmail-newu
%attr(0711,root,qmail) /usr/bin/qmail-pw2u
#OMIT /usr/bin/qmail-qmqpc
%attr(06711,qmails,qmail) /usr/bin/qmail-qread
/usr/bin/qmail-qstat
%attr(04711,qmailq,qmail) /usr/bin/qmail-queue
%attr(0711,root,qmail) /usr/bin/qmail-remote
%attr(0711,root,qmail) /usr/bin/qmail-rspawn
%attr(0711,root,qmail) /usr/bin/qmail-send
/usr/bin/qmail-showctl
%attr(0700,root,qmail) /usr/bin/qmail-start
/usr/bin/qmail-tcpok
/usr/bin/qmail-tcpto
/usr/bin/qsmhook
%attr(0711,root,qmail) /usr/bin/splogger
/usr/bin/tcp-env

/usr/man/man1/tcp-env.1
/usr/man/man5/addresses.5
/usr/man/man5/dot-qmail.5
/usr/man/man5/envelopes.5
/usr/man/man5/maildir.5
/usr/man/man5/mbox.5
/usr/man/man5/qmail-control.5
/usr/man/man5/qmail-header.5
/usr/man/man5/qmail-log.5
/usr/man/man5/qmail-users.5
/usr/man/man5/tcp-environ.5
/usr/man/man7/forgeries.7
/usr/man/man7/qmail-limits.7
/usr/man/man7/qmail.7
/usr/man/man8/qmail-clean.8
/usr/man/man8/qmail-command.8
/usr/man/man8/qmail-getpw.8
/usr/man/man8/qmail-init.8
/usr/man/man8/qmail-local.8
/usr/man/man8/qmail-lspawn.8
/usr/man/man8/qmail-newmrh.8
/usr/man/man8/qmail-newu.8
/usr/man/man8/qmail-pw2u.8
#OMIT /usr/man/man8/qmail-qmqpc.8
/usr/man/man8/qmail-qread.8
/usr/man/man8/qmail-qstat.8
/usr/man/man8/qmail-queue.8
/usr/man/man8/qmail-remote.8
/usr/man/man8/qmail-rspawn.8
/usr/man/man8/qmail-send.8
/usr/man/man8/qmail-showctl.8
/usr/man/man8/qmail-start.8
/usr/man/man8/qmail-tcpok.8
/usr/man/man8/qmail-tcpto.8
/usr/man/man8/splogger.8

/var/lock/svc/qmail

%attr(-,qmaill,qmail) /var/log/qmail

/var/qmail

%files pop3d
%defattr(-,root,qmail)
/etc/rc.d/init.d/pop3d
%config(noreplace) /etc/tcpcontrol/pop-3.cdb
%config(noreplace) /etc/tcpcontrol/pop-3.rules
/usr/bin/qmail-pop3d
%attr(700,root,qmail) /usr/bin/qmail-popup
/var/lock/svc/pop3d
%attr(-,qmaill,qmail) /var/log/pop3d
/usr/man/man8/qmail-pop3d.8
/usr/man/man8/qmail-popup.8

%files qmqpd
%defattr(-,root,qmail)
/etc/rc.d/init.d/qmqpd
%config(noreplace) /etc/tcpcontrol/qmqp.cdb
%config(noreplace) /etc/tcpcontrol/qmqp.rules
/usr/bin/qmail-qmqpd
/var/lock/svc/qmqpd
%attr(-,qmaill,qmail) /var/log/qmqpd
/usr/man/man8/qmail-qmqpd.8

%files qmtpd
%defattr(-,root,qmail)
/etc/rc.d/init.d/qmtpd
%config(noreplace) /etc/tcpcontrol/qmtp.cdb
%config(noreplace) /etc/tcpcontrol/qmtp.rules
/usr/bin/qmail-qmtpd
/var/lock/svc/qmtpd
%attr(-,qmaill,qmail) /var/log/qmtpd
/usr/man/man8/qmail-qmtpd.8

%files smtpd
%defattr(-,root,qmail)
/etc/rc.d/init.d/smtpd
%config(noreplace) /etc/tcpcontrol/smtp.cdb
%config(noreplace) /etc/tcpcontrol/smtp.rules
/usr/bin/qmail-smtpd
/var/lock/svc/smtpd
%attr(-,qmaill,qmail) /var/log/smtpd
/usr/man/man8/qmail-smtpd.8

%files utils
%defattr(-,root,qmail)
%config /etc/profile.d/*

/usr/bin/mailq
/usr/bin/bouncesaying
/usr/bin/condredirect
/usr/bin/datemail
/usr/bin/elq
/usr/bin/except
/usr/bin/forward
/usr/bin/maildir2mbox
/usr/bin/maildirmake
/usr/bin/maildirwatch
/usr/bin/mailsubj
/usr/bin/pinq
/usr/bin/predate
/usr/bin/preline
/usr/bin/qail
/usr/bin/qbiff
/usr/bin/qmail-inject
/usr/bin/qreceipt
/usr/lib/sendmail
/usr/man/man1/bouncesaying.1
/usr/man/man1/condredirect.1
/usr/man/man1/except.1
/usr/man/man1/forward.1
/usr/man/man1/maildir2mbox.1
/usr/man/man1/maildirmake.1
/usr/man/man1/maildirwatch.1
/usr/man/man1/mailsubj.1
/usr/man/man1/preline.1
/usr/man/man1/qbiff.1
/usr/man/man1/qreceipt.1
/usr/man/man8/qmail-inject.8
/usr/sbin/sendmail
